#pragma once
//
#include "list.h"
#include "field.h"
#include "fieldlist.h"
#include "controller.h"
#include <QSqlQuery>
//


class AbstractConnection  
{

public:
	AbstractConnection();
	virtual bool Login(string username, string password, string hostname, unsigned short port,string database)=0;
	virtual string getUsername()=0;
	virtual string getHostname()=0;
	virtual string getPort()=0;
	virtual string CurrentDatabase()=0;
	virtual  string CurrentRecord()=0;
	virtual List getDatabaseList()=0;
	virtual List getTableList(string database)=0;
	virtual List * getFirstRecord(List * FieldList)=0;
	virtual List * getNextRecord(int)=0;
	virtual FieldList * getRecord(string table)=0;
	virtual void update(List * FieldList,List * field,List * original)=0;
	virtual string getPrimaryKey()=0;
	virtual string currentTable()=0;
	virtual string currentDB()=0;
	virtual ~AbstractConnection();
	virtual void Logout()=0;
	virtual int getRows()=0;
	virtual void insert(List *, List *)=0;
	virtual void setEncoding(string)=0;
	virtual string getEncoding()=0;
	virtual void setController(Controller *)=0;
	virtual void directMigration(List)=0;
	virtual void setDatabase(string)=0;
};

