#include "conimpl.h"
#include "controller.h"
#include "myspeller.h"
#include "qtconnection.h"
#include <QMessageBox>
//
ConImpl::ConImpl(QWidget * parent, Qt::WFlags f) 
	: QMainWindow(parent, f)
{
	setupUi(this);
	connect(Username, SIGNAL( triggered()), this, SLOT( currentUser()) );
	connect(Database, SIGNAL( triggered()), this, SLOT (currentDB())  );
	connect(Hostname, SIGNAL( triggered()), this, SLOT (currentHost()) );
	connect(Port_Number, SIGNAL( triggered()), this, SLOT( currentPort()));
	connect(checkedFields, SIGNAL( triggered()), this, SIGNAL( fields()) );
	connect(New_SpellCheck, SIGNAL( triggered()), this, SIGNAL( newspell())); 
	connect(Logout, SIGNAL( triggered()), this, SLOT( closeconn()) );
	connect(Preferences,SIGNAL( triggered()), this, SIGNAL( showopt()));
}
//

void ConImpl::currentUser(){
QMessageBox::about(this,"Username",link->getConnection()->getUsername().c_str());
}

void ConImpl::currentDB(){
QMessageBox::about(this,"Database",link->getConnection()->CurrentDatabase().c_str());
}

void ConImpl::currentHost(){
QMessageBox::about(this,"Hostname",link->getConnection()->getHostname().c_str());
}

void ConImpl::currentPort(){
QMessageBox::about(this,"Port Number",link->getConnection()->getPort().c_str());
}

void ConImpl::closeconn(){
	link->getConnection()->Logout();
}

void ConImpl::setController(Controller * link){
	if (link)
		this->link=link;
}

