#include "controller.h"
#include "recordspeller.h"
#include <string>
using namespace std;
//
void Controller::setSansFautes(bool etat){
	sansFautes=etat;
}

Controller::Controller(AbstractSpeller * speller,AbstractConnection * source,AbstractConnection * dest){
sansFautes=true;
spell=false;
DictList=0;	
if (speller && source && dest){
this->destination=dest;
this->speller=speller;
this->connection=source;
this->source=source;
source->setController(this);
destination->setController(this);
speller->setController(this);
SourceFields=0;
DestFields=0;

gui=new GUI;
gui->setController(this);
numRows=0;

MyThread=gui->getThread();
MySpellThread=gui->getSpellThread();
}

else if(speller && source && dest==0)
{
this->destination=0;
this->speller=speller;
this->connection=source;
this->source=source;
source->setController(this);
speller->setController(this);
SourceFields=0;
DestFields=0;

gui_speller=new GUI_SPELLER;
gui_speller->setController(this);

MySpellThread=gui_speller->getSpellThread();

}
else {
this->speller=0;
this->source=0;
this->destination=0;
}






}

bool Controller::Login(string user,string pass,string host,int port,string database){
return (connection->Login(user,pass,host,port,database))?true:false;
}

List * Controller::getDatabaseList(){
List * DbList=new List(connection->getDatabaseList());
return DbList;

}

List * Controller::getTableList(string database){
List * tblList=new List(connection->getTableList(database));
return tblList;
}

FieldList * Controller::getRecord(string table){
FieldList * record=connection->getRecord(table);
return record;
}

void Controller::printSuggList(List * SuggList){
MySpellThread->emitPrint(SuggList);

}

void Controller::checkedLine(string line){

}

void Controller::linkSpeller()
{
}

void Controller::addField(string field){
CheckedFields.addElement(field);
if (destination==0)
	gui_speller->fieldImplPopulate(CheckedFields);
	else
 gui->fieldImplPopulate(CheckedFields);
}

void Controller::replace(char * repl){
speller->replace(repl);
}

void Controller::showContext(char * show){
MySpellThread->emitShowContext(show);
}

void Controller::configure(string text){
speller->configure(text);
}

void Controller::update(List* FieldList,List* checkedField,List* Field){

if (destination)
	insert(checkedField);
	else{	
		
		if (sansFautes==true)
	;
	else
connection->update(FieldList,checkedField,Field);
}

}

void Controller::insert(List Record){
	destination->insert(DestFields,&Record);

}

void Controller::insert(List * record){
	destination->insert(DestFields,record);
}

void Controller::addInsert(){
			MyThread->emitAddInsert();
}

bool Controller::checked(string field){
for (int i=0;i<CheckedFields.size();i++)
if (field==CheckedFields.getElement(i))
return true;
return false;
}

List * Controller::getDictList(){
DictList=speller->getDictList();
return DictList;
}


List * Controller::getFirstRecord(List * fields){
	return connection->getFirstRecord(fields);
}

List * Controller::getNextRecord(int n){
	sansFautes=true;
	return connection->getNextRecord(n);
}


void Controller::setSpellerOption(string option,string value){
speller->setConfig(option,value);
}

void Controller::addWordToSpeller(string word){
speller->addWord(word);
}

void Controller::IgnoreAll(string word){
speller->IgnoreAll(word);
}

string Controller::currentTable(){
	return connection->currentTable();
}

string Controller::currentDB(){
	return connection->currentDB();
}

string Controller::currentField(){
	return speller->currentField();
}

Controller::~Controller(){
delete gui;	
delete gui_speller;
delete source;
if (destination)
delete destination;
delete speller;
if (SourceFields)
	delete SourceFields;
if (DestFields)
	delete DestFields;
	
}

void Controller::configureMigration(List * SourceFields){
	this->SourceFields=SourceFields;	
}

void Controller::configureDestFields(List DestFields){
	this->DestFields=new List(DestFields);
	switchToSource();
	if (!spell)
	{
		gui->setMigrating();
		List * record=getFirstRecord(SourceFields);
		if (record->size()){
			insert(*record);
			linkInsert();
		}
		else 
			gui->setFinish();
		delete record;
	}
	else
	{
		switchToSource();
		configure(SourceFields);
}

}

void Controller::linkInsert(){
	List * record=getNextRecord(SourceFields->size());
	if (record->size()){
		insert(*record);
		linkInsert();
	}
	else{
		gui->setFinish();
	delete record;
}
}

void Controller::configure(List * FieldList){
	speller->configure(FieldList);
}

void Controller::setConnectionEncoding(string encoding){
	if (connection==source)
		setSpellerOption(string("encoding"),encoding);
	connection->setEncoding(encoding);
}

void Controller::setSourceEncoding(string encoding){
	source->setEncoding(encoding);
}

void Controller::setDestEncoding(string encoding){
	destination->setEncoding(encoding);
	
	
}

string Controller::getEncoding(){
	return connection->getEncoding();
}

int Controller::fieldsCount(){
	
	if (SourceFields)
		return SourceFields->size();
}




void Controller::configureDest(List DestFields){
	this->DestFields=new List(DestFields);
	if (spell){
		switchToSource();
	//	/*
	//	replaceSpeller();
	    speller->setSpellOnly(false);
		MySpellThread->setSourceFields(SourceFields);
		MySpellThread->setController(this);
		MySpellThread->start();
	//	*/
	//	configure(SourceFields);
	}
		else {
			MyThread->setSourceFields(SourceFields);
			MyThread->setSource(source);
			MyThread->start();
		}
}

void Controller::switchToSource(){
	connection=source;
}

void Controller::switchToDest(){
	connection=destination;
}

void Controller::done(){
	MySpellThread->emitDone();
}

void Controller::error(QString const & text){
	if (MyThread)
	MyThread->emitError(text);
	else MySpellThread->emitError(text);
}

void Controller::replaceSpeller(){
delete speller;
speller=new RecordSpeller;
speller->setController(this);
}

void Controller::flushIgnoreList(){
speller->flushIgnoreList();
}

void Controller::sleep(int n){
	MySpellThread->doMsleep(n);
}

void Controller::linkRecords(){
	speller->linkRecord();
}

void Controller::setPartition(int n){
	speller->setMaxCount(n);
}

void Controller::configureSpeller(List * FieldList){
	this->SourceFields=FieldList;
	speller->setSpellOnly(true);
	MySpellThread->setSourceFields(FieldList);
	MySpellThread->setController(this);
	MySpellThread->start();	
}

void Controller::complete(){
	MySpellThread->emitComplete();

}

void Controller::linkRecord(){
	MySpellThread->emitLinkRecord();
}

void Controller::addFields(){
	for (int i=0;i<SourceFields->size();++i)
    addField(SourceFields->getElement(i));
}

void Controller::setDatabase(string db){
	connection->setDatabase(db);
}

