#ifndef CONTROLLER_H
#define CONTROLLER_H

#include "gui.h"
#include "gui_speller.h"
#include "abstractconnection.h"
#include "list.h"
#include "workerthread.h"
#include "migimpl2.h"
#include "treeimpl.h"

#include <QString>

class AbstractConnection;
class List;
class AbstractSpeller;
class GUI;
class GUI_SPELLER;
class workerThread;
class spellerThread;

class Controller
{

GUI * gui;
GUI_SPELLER * gui_speller;

workerThread * MyThread;
spellerThread * MySpellThread;
AbstractConnection * connection;
AbstractConnection * source;
AbstractConnection * destination;
AbstractSpeller * speller;
List * SourceFields;
List * DestFields;
List CheckedFields;
bool sansFautes;
bool spell;
int numRows;

List * DictList;



public:
	Controller(AbstractSpeller *,AbstractConnection*, AbstractConnection* dest=0);
	AbstractConnection * getConnection(){
	return connection;
}
void toSpell(bool b){
	spell=b;
}
bool Login(string,string,string,int,string);
List * getDatabaseList();
List * getTableList(string);
FieldList * getRecord(string table);
void printSuggList(List*);
void checkedLine(string);
void replace(char *);
void showContext(char *);
void configureField(string);
void linkSpeller();
void configure(string);
void configure(List*);
void addField(string);
void update(List*,List*,List*);
bool checked(string field);
List * getDictList();
void setSpellerOption( string option,string value);
void addWordToSpeller(string);
void IgnoreAll(string);
List * getFirstRecord(List*);
List * getNextRecord(int);
string currentTable();
string currentDB();
string currentField();
void setSansFautes(bool);
void configureMigration(List * SourceFields);
void configureDestFields(List DestFields);
void configureDest(List DestFields);
void linkInsert();
void insert(List);
void insert(List*);
void setConnectionEncoding(string);
void setSourceEncoding(string);
void setDestEncoding(string);
string getEncoding();
int fieldsCount();
List * getSourceFields(){
	return SourceFields;
}
void addInsert();
void setNumRows(int rows){
	numRows=rows;
}
int getNumRows(){
	return numRows;
}
void switchToSource();
void switchToDest();
void done();
void error(const QString &);
void replaceSpeller();
void flushIgnoreList();
void configureRecord(List*);
void linkRecords();
void sleep(int n);
void setPartition(int n);
void configureSpeller(List *);
void linkRecord();
void complete();
void addFields();
void setDatabase(string);
~Controller();
};
#endif
