#include "gui.h"
#include <QThread>
//

GUI::GUI(  ) 
{

link=0;
mainwin=new MigImpl2;
win=new Impl(mainwin->getWidget());
win21=new Impl(mainwin->getWidget());
win9=0;
win5=new checkImpl;
win6=new fieldImpl;
tree=new treeImpl(mainwin->getWidget());
notice=new noticeImpl;
win10=new dbDiagImpl;

MyThread=new workerThread;
MySpellThread=new spellerThread;

win5->hide();
win6->hide();
win21->hide();
tree->hide();
notice->hide();

connect(mainwin, SIGNAL( fields()), win6, SLOT( show()));
connect(mainwin, SIGNAL( showopt()), this, SLOT( createOpt()));

connect(win21, SIGNAL( success() ), tree, SLOT( populateDB() ));
connect(win21, SIGNAL( success() ), tree, SLOT( populateDB() ));
connect(win21, SIGNAL( success() ), tree, SLOT( show() ));

connect(win, SIGNAL( success() ), win21, SLOT( show() ));
connect(win,SIGNAL( success()), mainwin, SLOT( setDestination()));
connect(win21, SIGNAL( success()), mainwin, SLOT( setMigrating()));

connect(MySpellThread, SIGNAL( complete()), mainwin, SLOT( setFinish()));
connect(tree, SIGNAL( rst()), mainwin, SLOT( resetLcd()));

connect (MyThread, SIGNAL( done()), this, SLOT( done()));
connect (MyThread, SIGNAL( error(QString)), this, SLOT( showMessage(QString)));
connect(MyThread, SIGNAL( addInsert()), mainwin, SLOT( addInsert()));

connect(MySpellThread, SIGNAL( showContext(char *)),win5, SLOT(showContext(char *)));
connect(MySpellThread, SIGNAL( print(List *)), win5, SLOT( print(List *)));
connect(MySpellThread, SIGNAL( done()), this, SLOT( done()));
connect(MySpellThread, SIGNAL( done()), mainwin, SLOT( setFinish()));
connect(MySpellThread,SIGNAL( message(int )), this, SLOT( message(int)));
connect(MySpellThread,SIGNAL( complete()), this, SLOT( done()));

connect(tree, SIGNAL( clicker()), mainwin, SLOT( setProcess()));
connect(notice, SIGNAL( accepted()), this, SLOT( linkRecord()));
connect(notice, SIGNAL( rejected()), this, SLOT( aborted()));

connect(win, SIGNAL( valueChanged(string *)), win10, SLOT( check(string *)));
connect(win21, SIGNAL( valueChanged(string *)), win10, SLOT( check(string *)));

 
if (!win->isVisible())
win->show();
if (!mainwin->isVisible())
mainwin->show();
}

void GUI::setController(Controller * link){
	this->link=link;
	win->setController(link);
	win21->setController(link);
	win5->setController(link);
	win6->setController(link);
	tree->setController(link);
	mainwin->setController(link);
}

void GUI::print(List suggList){
	win5->print(&suggList);
}

void GUI::showCheckImpl(){
	win5->show();
}

void GUI::showContext(char * show){
	win5->showContext(show);
}

void GUI::addInsert(){
	mainwin->addInsert();
}

void GUI::setMigrating(){
	mainwin->setMigrating();
}

void GUI::setFinish(){
	mainwin->setFinish();
}

void GUI::fieldImplPopulate(List l){
	win6->populate(l);
}

void GUI::createOpt(){
	win9=new optImpl;
	win9->setController(link);
	win9->show();
	win9->populate();
}

void GUI::done(){
		mainwin->setInsert(link->getNumRows());
		setFinish();
		QMessageBox::about(0,tr("Info"),tr("Migration Done"));	
	
		
	}
	
void GUI::message(int n){
	notice->setText(n);
		notice->show();
	}
	
void GUI::aborted(){
		QMessageBox::about(0,tr("Info"),tr("Migration aborted"));	
}

void GUI::linkRecord(){
	link->linkRecords();
}