#ifndef GUI_H
#define GUI_H

#include <QObject>
#include <QMessageBox>
#include "migimpl2.h"
#include "controller.h"
#include "treeimpl.h"
#include "impl.h"
#include "fieldimpl.h"
#include "optimpl.h"
#include "checkimpl.h"
#include "workerthread.h"
#include "spellerthread.h"
#include "noticeimpl.h"
#include "dbdiagimpl.h"
//

class MigImpl2;
class treeImpl;
class Impl;
class fieldImpl;
class optImpl;
class checkImpl;
class workerThread;
class spellerThread;
class noticeImpl;
class dbDiagImpl;

//
class GUI  : private QObject
{
Q_OBJECT

private:

Controller * link;

MigImpl2 * mainwin;

treeImpl * tree;

Impl * win;
Impl * win21;
fieldImpl * win6;
optImpl * win9;
checkImpl * win5;

noticeImpl * notice;

dbDiagImpl * win10;

workerThread * MyThread;
spellerThread * MySpellThread;

public:
	GUI();
	void print(List suggList);
	void fieldImplPopulate(List checkedFields);
	void showCheckImpl();
	void showContext(char *);
	void addInsert();
	void setMigrating();
	void setFinish();
	void setController(Controller * link);
		workerThread * getThread(){
		return MyThread;
	}
		spellerThread * getSpellThread(){
			return MySpellThread;
		}
public slots:
	void done();
	void showMessage(QString text){
		QMessageBox::about(0,tr("Error"),text);	
	}
	void message(int);
	void linkRecord();
	void aborted();
	void createOpt();
};
#endif
