#include "impl4.h"
#include "list.h"
#include <QCheckBox>
#include <iostream>
//

Impl4::Impl4(QWidget * parent, Qt::WFlags f) 
	: QWidget(parent, f)
{
	setupUi(this);
	connect(checklist, SIGNAL( itemEntered(QListWidgetItem*)), this, SLOT( enableNext() ) );
	connect(checklist, SIGNAL( itemDoubleClicked(QListWidgetItem * )), this, SLOT( remField(QListWidgetItem *  ))); 
	connect(checklist, SIGNAL( itemDoubleClicked(QListWidgetItem * )), this, SLOT( populate())); 	   
	connect(next, SIGNAL( clicked()), this, SLOT( emitclicker()) );
	connect(this, SIGNAL( tableSet()), this, SLOT( populate()) );
	table->setHorizontalHeaderItem(0,new QTableWidgetItem(QString("Field")));
	table->setHorizontalHeaderItem(1,new QTableWidgetItem(QString("Type")));
	table->setHorizontalHeaderItem(2,new QTableWidgetItem(QString("Status")));
	enableNext();
}
//

void Impl4::enableNext(){
	next->setEnabled(true);
}


void Impl4::setTable(string table){
	Table->setText(QString(table.c_str()));
	tblName=table;
	emit tableSet();
}

void Impl4::addField(){
	checklist->addItem(QString(currentField->text()));
	if (checklist->count()==1) emit positiveCount();
}

void Impl4::remField(QListWidgetItem * item ){
	checklist->takeItem(checklist->row(item));
	if (checklist->count()==0) emit zeroCount();
}

void Impl4::disableNext(){
	next->setEnabled(false);
}

void Impl4::setCurrentField(QTableWidgetItem* field){
	currentField=field;
}

void Impl4::populate(){
		table->clearContents();
		checklist->clear();
		FieldList * record=link->getRecord(getTable());
		table->setRowCount(record->size());
		for (int i=0;i<record->size();i++) {
		if (link->checked(record->getField(i)->getNom().c_str())){	
		QCheckBox * item=new QCheckBox(this);
		item->setCheckState(Qt::Checked);
		item->setEnabled(false);
		table->setCellWidget(i,2,item);
	}
		else {	
		QCheckBox * item=new QCheckBox(this);
		item->setCheckState(Qt::Unchecked);
		item->setEnabled(false);
		table->setCellWidget(i,2,item);
	}
		table->setItem(i,1,new QTableWidgetItem(QString(record->getField(i)->getType().c_str())) );	
		table->setItem(i,0,new QTableWidgetItem(QString(record->getField(i)->getNom().c_str())) );	
		}
		delete record;
}

List Impl4::getFieldList(){
	List FieldList;
	for (int i=0;i<checklist->count();i++)
		FieldList.addElement(checklist->item(i)->text().toStdString());
	return FieldList;
}


void Impl4::emitclicker(){
	List * emitted=new List;
	cout<<checklist->count();
	for (int i=0;i<checklist->count();i++)
		{
		emitted->addElement(checklist->item(i)->text().toStdString());
		std::cout<<emitted->getElement(i);
	}
	link->configureSpeller(emitted);
}

void Impl4::setController(Controller * link){
if (link)
this->link=link;
}



