#pragma once
 

#include "list.h"
#include "aspell.h"
#include <iostream>
#include <string>
#include <string.h>
#include <stdio.h>
#include <vector>
#include "controller.h"
#include "abstractspeller.h"
using namespace std;


#define check_for_error(speller)                                  \
  if (aspell_speller_error(speller) != 0) {                       \
    printf("Error: %s\n", aspell_speller_error_message(speller)); \
    break;                                                        \
  }

#define check_for_config_error(config)                            \
  if (aspell_config_error(config) != 0) {                         \
    printf("Error: %s\n", aspell_config_error_message(config));   \
     throw 1;                                                     \
  }
  

class Controller;

class MySpeller: public AbstractSpeller
{
AspellConfig * config;
AspellSpeller * spell_checker;
AspellCanHaveError * ret;
AspellDocumentChecker * checker;
AspellToken token;
string language;
string encoding;

char line[256];
char * word_begin;
int diff;

protected:
Controller * link;
List isIgnored;

public:
void setController(Controller *);

 List * getDictList();

MySpeller(){
  language="fr";
  encoding="UTF-8";
 	
  config = new_aspell_config();

  aspell_config_replace(config, "lang", "fr");

  aspell_config_replace(config,"encoding","UTF-8");
	
  aspell_config_replace(config,"normalize","true");
	
  ret = new_aspell_speller(config);
  
   delete_aspell_config(config);
  

  if (aspell_error(ret) != 0) {
    printf("Error: %s\n",aspell_error_message(ret));
    delete_aspell_can_have_error(ret);
  }
  spell_checker = to_aspell_speller(ret);
  config = aspell_speller_config(spell_checker);
}

void setConfig(string option,string value);


void replace(char *);


void flush();
void linker();
void next();

void configure(std::string);

void addWord(string);
void IgnoreAll(string);
void ignoreList(string);
void flushIgnoreList();


virtual ~MySpeller();

};


