/*
 *  qtconnection.cpp
 *  
 *
 *  Created by wassim on 3/16/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include "qtconnection.h"
#include "textfield.h"
#include <stdio.h>
#include <string.h>
#include <iostream>
#include <QSqlField>
#include <QMessageBox>


string fromEncoding(QString s,string encoding){
		QTextCodec * codec=QTextCodec::codecForName(encoding.c_str());
		string temp=string(codec->fromUnicode(s).data());
		return temp;
}

QString toEncoding(string s,string encoding){
	QTextCodec * codec=QTextCodec::codecForName(encoding.c_str());
	QString temp=codec->toUnicode(s.c_str());
	return temp;
}

int qtConnection::counter=0;

string apost(string query){
int i=0;
while (i!=-1){
i=query.find("'",i+2);

if (i!=-1) query.insert(i,"'");

}
return query;
}

List qtConnection::getDatabaseList(){
List dblist;
string q;
if (database==string("Oracle")){
		dblist.addElement(dbName);
}
else 
{
if (database==string("PostgreSql"))
	q=string("select datname from pg_database");
else if (database==string("MySql"))
q=string("select distinct table_schema from tables");
QSqlQuery query(q.c_str(),*db);
query.setForwardOnly(true);
while (query.next()) {
dblist.addElement(query.value(0).toString().toStdString());
}
}
return dblist;
}

List qtConnection::getTableList(string database){
if (db)
	if (db->isOpen())
db->close();
db->setDatabaseName(database.c_str());
db->open();
if (!db->isOpen()) throw "no connection";

dbName=database;
List tlist;
QStringList list=db->tables();

for (int i=0;i<list.count();++i)
tlist.addElement(list[i].toStdString());

return tlist;

}

FieldList * qtConnection::getRecord(string table){
	tblName=table;
	string oid;
	FieldList * rec=new FieldList;
	if (!db->isOpen()) throw "no connection";
		if (database==string("PostgreSql")){
	table="SELECT c.oid FROM pg_catalog.pg_class c LEFT JOIN pg_catalog.pg_namespace n ON n.oid = c.relnamespace WHERE c.relname ~ '^("+tblName+")$' AND pg_catalog.pg_table_is_visible(c.oid)";
	QSqlQuery query(db->exec(table.c_str()));
	if (query.next())
		oid=query.value(0).toString().toStdString();
	string commande="SELECT a.attname,pg_catalog.format_type(a.atttypid, a.atttypmod) FROM pg_catalog.pg_attribute a WHERE a.attrelid = '"+oid+"' AND a.attnum > 0 AND NOT a.attisdropped ORDER BY a.attnum";
	QSqlQuery query2(db->exec(commande.c_str()));
	int i=0;
	while (query2.next()) {
		rec->addField(new TextField(query2.value(0).toString().toUtf8().data()));
		rec->getField(i)->setType(query2.value(1).toString().toUtf8().data());
	i++;
	}
}

else if (database==string("MySql")) {
	db->close();
	db->setDatabaseName("information_schema");
	db->open();
	if ( !db->isOpen() ) throw "no connection";
	table="select column_name,data_type from columns where table_name='"+tblName+"'";
	QSqlQuery query(db->exec(table.c_str()));
	int i=0;
	while (query.next()){
		rec->addField(new TextField(query.value(0).toString().toUtf8().data()));
		rec->getField(i)->setType(query.value(1).toString().toUtf8().data());
	i++;
	}
}
	else if (database==string("Oracle")) {
	db->close();
	db->setDatabaseName("information_schema");
	db->open();
	if ( !db->isOpen() ) throw "no connection";
	table="select column_name,data_type from user_tab_columns where table_name='"+tblName+"'";
	QSqlQuery query(db->exec(table.c_str()));
	int i=0;
	while (query.next()){
		rec->addField(new TextField(query.value(0).toString().toUtf8().data()));
		rec->getField(i)->setType(query.value(1).toString().toUtf8().data());
	i++;
	}	
	}
	
	db->close();
	db->setDatabaseName(dbName.c_str());
	db->open();
	
	return rec;	
}

void qtConnection::directMigration(List fields){

rows=0;
string commande("select ");
for (int i=0;i<fields.size()-1;i++)
commande+=fields.getElement(i)+",";
commande+=fields.getElement(fields.size()-1);
commande+=" from "+tblName;
//cout<<"commande sql "<<commande<<endl;
q= new QSqlQuery(db->exec(commande.c_str()));
if (q->lastError().databaseText().isEmpty()) 
				;
							else QMessageBox::about(0,"Error","error during insert query "+q->lastError().databaseText());	
int n=link->getSourceFields()->size();
rows=q->size();
link->setNumRows(rows);
while (q->next())
	{
		List liste;
		for (int i=0;i<n;++i)
	liste.addElement(fromEncoding(q->value(i).toString(),encoding));
	link->insert(liste);
}
}

List * qtConnection::getFirstRecord(List * fields){
List * liste=new List;
rows=0;
int n=fields->size();
string commande("select ");
for (int i=0;i<n-1;i++)
commande+=fields->getElement(i)+",";
commande+=fields->getElement(n-1);
commande+=" from "+tblName;
//cout<<"commande sql "<<commande<<endl;

q=new QSqlQuery(db->exec(commande.c_str()));
q->setForwardOnly(true);
rows=q->size();
link->setNumRows(rows);
//cout<<"number of rows affected :"<<rows;

if (q->next())
for (int i=0;i<n;++i){
	liste->addElement(fromEncoding(q->value(i).toString(),encoding));
}
//cout<<"taille du record: "<<liste->size()<<endl;
return liste;
}

List * qtConnection::getNextRecord(int n){
List * liste=new List;
if (q->next()){
for (int i=0;i<n;++i)
			liste->addElement(fromEncoding(q->value(i).toString(),encoding));
}
return liste;
}

void qtConnection::update(List * FieldList,List * record,List * original){
	if (db->isOpen()){
			string commande="update "+tblName+" set ";
			string fields="(";
			string oldRecord="(";
			string newRecord="(";
			int n1=FieldList->size();
			for (int j=0;j<n1-1;++j){
				fields+=FieldList->getElement(j)+",";
			}
			int n2=record->size();
			for (int j=0;j<n2-1;++j){
				newRecord+="'"+apost(record->getElement(j))+"',";
				oldRecord+="'"+apost(original->getElement(j))+"',";
			}
				fields+=FieldList->getElement(n1-1)+")";
				newRecord+="'"+apost(record->getElement(n2-1))+"')";
				oldRecord+="'"+apost(original->getElement(n2-1))+"')";
				commande+=fields+" = "+newRecord+" where "+fields+" = "+oldRecord;
				
		QSqlQuery qsqlq=db->exec(toEncoding(commande,encoding));
		if (qsqlq.lastError().databaseText().isEmpty())
				cout<<"update done with commande: "<<commande<<endl;
		else
			link->error(qsqlq.lastError().databaseText());

			}	
		}

string qtConnection::getPrimaryKey(){
return db->primaryIndex(QString(tblName.c_str())).name().toStdString();
}

string qtConnection::currentTable(){
	return tblName;
}

string qtConnection::currentDB(){
	return dbName;
}

void qtConnection::insert(List * FieldList,List * record){
	if (db->isOpen()){
			string commande="insert into  "+tblName;
			string fields="(";
			string newRecord="(";
			int recordSize=record->size();
			for (int j=0;j<FieldList->size()-1;++j){
				fields+=FieldList->getElement(j)+",";
			}
			for (int j=0;j<recordSize-1;++j){
				newRecord+="'"+apost(record->getElement(j))+"',";
			}
				fields+=FieldList->getElement(FieldList->size()-1)+")";
				newRecord+="'"+apost(record->getElement(recordSize-1))+"')";
				commande+=fields+" values "+newRecord;
		
	QSqlQuery qsqlq=db->exec(toEncoding(commande,encoding));
	if (qsqlq.lastError().databaseText().isEmpty()) {
				link->addInsert();
				cout<<"insert done with command: "<<commande<<endl;
			}
							else
								link->error(qsqlq.lastError().databaseText());

						//	 QMessageBox::about(0,"Error","error during insert query "+qsqlq.lastError().databaseText());
	
			}	
}

string qtConnection::getEncoding(){
	return encoding;
}

qtConnection::~qtConnection(){
if (q)
delete q;
if (db){
db->close();
delete db;
}
}
