/*
 *  qtconnection.h
 *  
 *
 *  Created by wassim on 3/16/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */
#pragma once 

#include "abstractconnection.h"

#include <QApplication>
#include <QtSql>
#include <QSqlDatabase>
#include <QtGui>
#include <QSqlQuery>
#include <iostream>
#include <string>
#include "controller.h"

using namespace std;
class Controller;

class qtConnection : public AbstractConnection 
{
Controller * link;
string database;
static int counter;
string dbName,tblName,login,pass,port,host;
QSqlDatabase * db;
QSqlQuery * q;
int rows;
string encoding;
int columns;
public:
void setController(Controller * link){
	this->link=link;
}
qtConnection():AbstractConnection(),encoding("UTF-8"){
rows=0;
}

bool Login(string username, string password, string hostname, unsigned short port,string database){
counter++;
this->database=database;
string type;
char buffer[3];
sprintf(buffer,"%d",counter);
string name="connection"+string(buffer);
if (database==string("PostgreSql")){
	type=string("QPSQL");
	dbName="postgres";
}
	else if (database==string("MySql")){
	type=string("QMYSQL");
	dbName="information_schema";
}
	else if (database==string("Oracle"))
	{
		type=string("QOCI");
	}
db= new QSqlDatabase(QSqlDatabase::addDatabase(QString(type.c_str()),QString(name.c_str())));
pass=password;
login=username;
host=hostname;
db->setDatabaseName(dbName.c_str());
db->setUserName(username.c_str());
db->setPassword(password.c_str());
db->setHostName(hostname.c_str());
db->setPort((int)port);
return db->open();

}

string getHostname(){
if (db->isOpen())
return db->hostName().toStdString();
else
return string("no connection");
}

string getUsername(){
if (db->isOpen())
return db->userName().toStdString();
else return string("no connection");
}

string getPort(){
if (db->isOpen()) {
char buffer[10];
sprintf(buffer,"%d",db->port());
return string(buffer);
}
else 
return string("no connection");
}

string CurrentDatabase(){
if (db->isOpen()) 
return db->databaseName().toStdString();
else return string("no connection");
}

string CurrentRecord(){
if (db->isOpen())
return tblName;
else return string("no connection");
}

List getDatabaseList();
	List getTableList(string database);
	FieldList * getRecord(string table);
	List getField(string name);
	void update(List*,List*,List* );
	void Logout(){
		db->close();
}

string getPrimaryKey();
~qtConnection();
List * getNextRecord(int);
List * getFirstRecord(List *);
string currentTable();
string currentDB();

void insert(List*,List*);

int getRows(){
	return rows;
}
void setEncoding(string encoding){
	this->encoding=encoding;
}
string getEncoding();
void directMigration(List);

void setDatabase(string db){
	dbName=db;
}

};
