#include "treeimpl.h"
#include "list.h"
//
treeImpl::treeImpl( QWidget * parent, Qt::WFlags f) 
	: QWidget(parent, f)
{
	setupUi(this);
	treeWidget->setAcceptDrops(false);
	treeWidget2->setAcceptDrops(false);
	connect(treeWidget,SIGNAL(itemDoubleClicked ( QTreeWidgetItem * , int)),this, SLOT(populate1(QTreeWidgetItem *,int)));
	connect(treeWidget2,SIGNAL(itemDoubleClicked ( QTreeWidgetItem * , int)),this, SLOT(populate2(QTreeWidgetItem *,int)));
	connect(insert, SIGNAL(clicked()),this, SLOT(migrate()));
	connect(insert, SIGNAL( clicked()), this, SIGNAL( clicker()));
	connect(reset, SIGNAL( clicked()), this, SLOT(populateDB()));
	connect(reset,SIGNAL( clicked()), this, SIGNAL( rst()));
	
}
//

void treeImpl::setController(Controller * link){
	this->link=link;
}

void treeImpl::populateDB(bool n){
		treeWidget2->setAcceptDrops(false);
		List * DbList=link->getDatabaseList();
		if (n){
		treeWidget->clear();
		treeWidget->setDragEnabled(false);
		for (int i=0;i<DbList->size();i++){
			QTreeWidgetItem * it=new QTreeWidgetItem(QStringList(QString(DbList->getElement(i).c_str())));
		treeWidget->addTopLevelItem(it);
		it->setText(1,QString("database"));
	
	}
}
		else{
			treeWidget2->clear();
			for(int i=0;i<DbList->size();++i){
				QTreeWidgetItem * it=new QTreeWidgetItem(QStringList(QString(DbList->getElement(i).c_str())));
		treeWidget2->addTopLevelItem(it);
		it->setText(1,QString("database"));
}
	}
		delete DbList;
}

void treeImpl::populateTbl(QTreeWidgetItem * database,bool n){
	database->takeChildren();
	if (n)
		link->switchToSource();
		else
			link->switchToDest();
	List * tblList=link->getTableList(database->text(0).toStdString());
	for (int i=0;i<tblList->size();i++){
		QTreeWidgetItem * it =new QTreeWidgetItem(QStringList(QString(tblList->getElement(i).c_str())));
		database->addChild(it);
		it->setText(1,QString("table"));
	}
	delete tblList;
}

void treeImpl::populateFld(QTreeWidgetItem * table,bool n){
	 table->takeChildren();
	 if (n)
	 	link->switchToSource();
	 	else
	 		link->switchToDest();
	 FieldList * record=link->getRecord(table->text(0).toStdString());
		QTreeWidgetItem * it=new QTreeWidgetItem(*table);
		if (n){
			treeWidget->clear();
			treeWidget->addTopLevelItem(new QTreeWidgetItem(QStringList(QString("..."))));
			treeWidget->addTopLevelItem(it);
			treeWidget->setDragEnabled(true);
		}
			else {
				treeWidget2->clear();
				treeWidget2->addTopLevelItem(new QTreeWidgetItem(QStringList(QString("..."))));
				treeWidget2->addTopLevelItem(it);
				treeWidget2->setAcceptDrops(true);
			}
			for (int i=0;i<record->size();i++){
	 	it->addChild(new QTreeWidgetItem(QStringList(QString(record->getField(i)->getNom().c_str()))));
		it->child(i)->setText(1,QString(record->getField(i)->getType().c_str()));		
		}
		delete record;

}

void treeImpl::populate1(QTreeWidgetItem * item,int column){
	if (item->text(1)==QString("database") && column==0)
		populateTbl(item,true);
		else if (item->text(1)==QString("table") && column==0)
		populateFld(item,true);
		else if (item->text(0)==QString("..."))
		populateDB(true);
}

void treeImpl::populate2(QTreeWidgetItem * item,int column){
	if (item->text(1)==QString("database") && column==0)
		populateTbl(item,false);
		else if (item->text(1)==QString("table") && column==0)
		populateFld(item,false);
		else if (item->text(0)==QString("...")){
		populateDB(false);
		treeWidget2->setAcceptDrops(false);
	}
}

void treeImpl::populateDB(){
	populateDB(true);
	populateDB(false);
}

void treeImpl::migrate(){
	List* Source=new List;
	List Dest;
	int i=0;
	if (treeWidget2->topLevelItemCount()>2)
	QMessageBox::about(this,tr("Error"),tr("too many top level items"));
	else{
	QTreeWidgetItem * item=treeWidget2->topLevelItem(1);
	for (i=0;i<item->childCount();++i)
	{
		if (item->child(i)->childCount()>1){
			QMessageBox::about(this,tr("Error"),tr("Only one Field transfer per Field allowed"));	
			break;
		}
		else if (item->child(i)->childCount()==1) {
			Dest.addElement(item->child(i)->text(0).toStdString());
			Source->addElement(item->child(i)->child(0)->text(0).toStdString());
		}	
			
	}

if (i==item->childCount()){
	link->configureMigration(Source);
	if (spell->checkState()==Qt::Checked)
	    link->toSpell(true);
	    else link->toSpell(false);
	link->configureDest(Dest);
}
}	
}





